wp.domReady(function () {
    // Disable the richtext formats
    if (safeEditorSettings.formats) {
        for (let [format, value] of Object.entries(safeEditorSettings.formats)) {
            if (false == value) {
                wp.richText.unregisterFormatType(format);
            }
        }
    }
});

// Disable block-specific options
wp.hooks.addFilter('blocks.registerBlockType', 'safe-block-editor', function (blockSettings, blockName) {

    let supports = blockSettings.supports;

    // Override supports with our own
    if (safeEditorSettings.supports) {
        supports = Object.assign({}, supports, safeEditorSettings.supports);
    }

    // Maybe remove block from inserter
    if (-1 < safeEditorSettings.blocksBlacklist.indexOf(blockName)) {
        supports = Object.assign({}, supports, { inserter: false });
    }

    // Override block settings
    blockSettings = Object.assign({}, blockSettings, { supports: supports, });

    // Maybe override styles
    if (safeEditorSettings.stylesBlackList.hasOwnProperty(blockName)) {
        const blacklistedStyles = safeEditorSettings.stylesBlackList[blockName];
        blockSettings.styles = blockSettings.styles.filter(function (style) {
            return blacklistedStyles.indexOf(style.name) === -1;
        });
    }

    return blockSettings;
});
